#include <stdio.h>

extern FILE *ofd;

static void GenWeightDoc ()
{
fprintf(ofd, "Normalized processor time (NPT) is processor time over the\n");
fprintf(ofd, "concurrent number of busy processors.  This accounts the\n");
fprintf(ofd, "elapsed time of the program to each function.\n\n");
}

void GenFlatDoc ()
{
fprintf(ofd, "Flat profile.\n\n");
fprintf(ofd,"This listing is sorted by the normalized processing time of each function by itself.\n");
GenWeightDoc();

fprintf(ofd, "%NPT    The percentage of the total running time\n");
fprintf(ofd, "        attributable to this function itself\n\n");

fprintf(ofd, "cumsecs A running sum of the NPT due to this function\n"); 
fprintf(ofd, "        and those listed above it.\n\n");

fprintf(ofd, "seconds The NPT (in seconds) due to this function.\n"); 
fprintf(ofd, "        This is the major sort for this listing.\n\n");

fprintf(ofd, "calls   The number of times this function was invoked, if\n");
fprintf(ofd, "        this function is profiled, else blank.\n\n");

fprintf(ofd,"name    The name of the function (and if it is a synchronization\n");
fprintf(ofd, "        object, the type of object, and who initialed it).\n");
fprintf(ofd, "        This is the minor sort for this listing.\n\n");
}


void GenGraphDoc ()
{
fprintf(ofd, "\nCall graph profile.\n\n");

fprintf(ofd, "This listing is sorted by the NPT of each function \n");
fprintf(ofd, "plus its descendents.\n\n");
GenWeightDoc();

fprintf(ofd, "Each function entry lists:\n\n");

fprintf(ofd,"Name    The name of the function (and if it is a synchronization\n");
fprintf(ofd, "        object, the type of object, and who initialed it).\n\n");

fprintf(ofd, "Index   The index of the function in this listing.\n\n");

fprintf(ofd, "Aggregation (optional)\n");
fprintf(ofd, "        The number of synchronization objects of the same name\n");
fprintf(ofd, "        whose measured data is combined in this entry.\n\n");

fprintf(ofd, "Weight  The amount of time due to this function and\n");
fprintf(ofd, "        its descendents, in seconds and as a percentage of\n");
fprintf(ofd, "        the elapsed time.\n\n");

fprintf(ofd, "Processor time\n");
fprintf(ofd, "        The sum of the time (in seconds) spent by each\n");
fprintf(ofd, "        processor in this function and its descendents.\n\n");

fprintf(ofd, "Average parallelism\n");
fprintf(ofd, "        The processor time over the NPT.\n\n");

fprintf(ofd, "Distribution of parallelism\n");
fprintf(ofd, "        # busy: total-NPT %NPT (self-NPT %NPT)\n");
fprintf(ofd, "        The NPT of this function, by itself and with its\n");
fprintf(ofd, "        descendents, split according to the number of busy\n");
fprintf(ofd, "        processors.  (Only non-zero items are printed.)\n\n");

fprintf(ofd, "Distribution of nominal parallelism\n");
fprintf(ofd, "        The time spent in this function, by itself and with its\n");
fprintf(ofd,"        descendents, split according to both the execution state\n");
fprintf(ofd, "        (busy, spinning, blocked, or ready) and the number\n"); 
fprintf(ofd, "        of ready or runnable threads (the nominal parallelism).\n");
fprintf(ofd, "        (Only non-zero items are printed.)\n\n");

fprintf(ofd, "Average queue length (only for synchronization objects)\n");
fprintf(ofd, "        The average number of threads (processors if it is a\n");
fprintf(ofd, "        spin object) in this queue.  For locks, it includes the\n");
fprintf(ofd, "        thread holding the lock, if any.  For dependencies, the\n");
fprintf(ofd, "        first number is the number who have checked in,\n");
fprintf(ofd, "        the second is the number who are waiting for others to\n");
fprintf(ofd, "        check in.  The distribution is also printed.\n\n");

fprintf(ofd, "Call graph links\n");
fprintf(ofd, "        Each parent link lists: the NPT propagated to the\n");
fprintf(ofd, "        parent by this function; the number of calls made by\n");
fprintf(ofd, "        the parent to this function; the total number of calls\n");
fprintf(ofd, "        to this function; the name of the parent; its index.\n\n");

fprintf(ofd, "        The function entry lists: the NPT of this function\n");
fprintf(ofd, "        by itself; its total NPT, including its descendents;\n");
fprintf(ofd, "        the number of times it calls itself, if any; the total\n");
fprintf(ofd,"        number of times it is called; its name; and its index.\n\n");

fprintf(ofd, "        Each child link lists: the the NPT propagated to\n"); 
fprintf(ofd, "        this function by the child; the number of calls made by\n");
fprintf(ofd, "        this function to the child; the total number of calls\n");
fprintf(ofd, "        made to the child; the name of the child; its index.\n\n\n");
}
