#define min(a,b)	(((a) < (b)) ? (a) : (b))
#define max(a,b)	(((a) < (b)) ? (b) : (a))

#define CALLER 0
#define CALLEE 1
#define NumDir 2


typedef struct call_info {
	Triple *start;
	int numTriples;
	int numCalls;
	} CallInfo;

typedef struct sample_data {
	char *name;
	int kind;
	char *parentName;
	int numAgg;

	int newId;

	MeasuredData *data;

	KidData *kids;
	int numKids;

	int dfsNum;

	CallInfo graph[NumDir];

	FLOAT weight[NumWho]; 

	} SampleData;


typedef struct link_data {
	Triple triple;
	FLOAT weight;
	BusyData *data;
	} LinkData;

/* For units of microseconds */
#define EPSILON		1		/* less than a microsecond is round-off error */
#define SIGNIFICANT	5000	/* less than 5 millisecs is invisible */

extern QuartzData qdata;
extern char *procNames[];
extern int numProcNames;

extern SampleData *dataList;
extern SampleData **sorted[NumWho];
extern int numTotal;
extern int numCalls;
extern Triple *byCallee;

extern FILE *ofd;

FLOAT tm2weight();
void UpdateIds();
int ObjNameCmp(), CallerCmp(), KidCmp();

void AggSynchList(), AggKidData(), AggTriplesByCaller(), CumulateBusy();
void ComputeData(), GenReport(), ComputeDistrib();
void GenFlatDoc(), GenGraphDoc();
void Display();

FLOAT ComputeSum(), ComputePtime(), ComputeAvgParallelism(), ComputeAvgLen();
FLOAT ComputeMax();
LinkData *FillLink();

void NDC_init(), NDCDrawLine(), NDC_clear(), NDC_flush(), NDC_close();
void NDCDrawBox(), NDCDrawSquare(), NDCDrawText();
