/* Handle all stuff about profiling synchronization objects */

#include "thread.h"
#include "synch.h"
#include <usclkc.h>
#include "quartzcommon.h"
#include "profile.h"
#include "internal.h"

#define InitSynch			NUMPROCS
#define InitSynchBunches	5

char *strcpy();

static void SynchSetup (s)
	SynchProfile *s;
	{
	int i;

	for (i = 0; i < InitSynch; i++, s++)
		{
		s->next = pP.freeSynch;
		pP.freeSynch = s;
		}
	}

/* SynchProfile.synchId is already set when we get it */
SynchProfile *SynchInit (name, kind)
	char *name;
	int kind;
	{
	register SynchProfile *p;

	SetStateOverhead();
	if ((p = pP.freeSynch) == NULL)
		{
		SynchSetup(MyShmalloc(SynchProfile, InitSynch));
		p = pP.freeSynch;
		}
	pP.freeSynch = p->next;

	p->type = SynchProfileType;
	p->status = ACTIVE;
	p->kind = kind;
	if (name)
		p->name = strcpy(MyShmalloc(char, strlen(name) + 1), name);
	else
		p->name = NULL;
	p->parentID = pP.thread->idStack.top->procID;
	p->thread = NULL;

	p->number[0] = 0;
	p->number[1] = 0;

	p->samples = NULL;
	GraphEntryInit(&p->g);
	SLNPInit(&p->graphLock);

	p->lastSample = GETUSCLK();

	p->next = pP.proc->synchList; 
	pP.proc->synchList = p;

	SetStateNormal();
	return(p);
	}
