/* Handle all stuff about stacks */
#include "thread.h"
#include "synch.h"
#include <usclkc.h>
#include "quartzcommon.h"
#include "profile.h"
#include "internal.h"

#define PAGESIZE 		(0x400/sizeof(int))

typedef struct stack_list {
	SpinLock lock;
	Stack *deadStacks;
	} StackQ;

static shared StackQ stackPool;

Stack *StackpoolGet ()
	{
    Stack *s;

	if (stackPool.deadStacks)
		{
		SpinLockAcquire(&stackPool.lock);
		if (s = stackPool.deadStacks)
			{
			stackPool.deadStacks = s->next;
			SpinLockRelease(&stackPool.lock);
			return(s);
			}
		SpinLockRelease(&stackPool.lock);
		}
	return(MyShmalloc(Stack, 1));
	}

void StackpoolPut (s)
	Stack *s;
	{
	SpinLockAcquire(&stackPool.lock);
	s->next = stackPool.deadStacks;
	stackPool.deadStacks = s;
	SpinLockRelease(&stackPool.lock);
	}

void StackpoolInit ()
	{
	stackPool.deadStacks = NULL;
	SpinLockInit(&(stackPool.lock), "stackPool");
	}
