/* Handle all stuff about threads */

#include "stdio.h"
#include "thread.h"
#include "synch.h"
#include <usclkc.h>
#include "quartzcommon.h"
#include "profile.h"
#include "internal.h"

typedef struct thread_pool {
	SpinLock lock;
	Thread *bunch;
	} ThreadPool;

static shared ThreadPool threadPool;

static void ThreadSetup ()
	{
	Thread *t, *b;
	int j;
#ifdef PROFILE
	IdStackEntry *s = MyShmalloc(IdStackEntry, ThreadsPerBunch*InitIdStackSize);
#endif

	t = MyShmalloc(Thread, ThreadsPerBunch);
	b = NULL;
	for (j = 0; j < ThreadsPerBunch; j++, t++)
		{
		t->type = ThreadType;
#ifdef PROFILE
		t->idStack.base = s;
		s += InitIdStackSize;
		t->idStack.limit = s - 1;
#endif
		ThreadPut(t, &b);
		}
	b->nextBunch = NULL;
	pP.deadThreads = b;
	}

void ThreadpoolInit ()
    {
	threadPool.bunch = NULL;
	SpinLockInit(&(threadPool.lock), "threadPool");
	}

void ThreadpoolGet ()	
	{
	pP.deadCount += ThreadsPerBunch;
	if (threadPool.bunch)
		{
		SpinLockAcquire(&threadPool.lock);
		if (pP.deadThreads = threadPool.bunch)
			{
			threadPool.bunch = pP.deadThreads->nextBunch;
			SpinLockRelease(&threadPool.lock);
			return;
			}
		SpinLockRelease(&threadPool.lock);
		}
	ThreadSetup();
	}

void ThreadpoolPut ()
	{
	Thread *b = pP.deadMiddle->next;

	SpinLockAcquire(&threadPool.lock);
	b->nextBunch = threadPool.bunch;
	threadPool.bunch = b;
	SpinLockRelease(&threadPool.lock);
	pP.deadMiddle->next = NULL;
	pP.deadCount -= ThreadsPerBunch; 
	}

#ifndef PRESTO

/*VARARGS*/
Thread *ThreadStart (fn, join, name, nargs)
	void (*fn)();
	int join;
	char *name;
	int nargs;
	{
	register Thread *t;
	register int *p;
	register int *bottom;
	int *top;

 	if (nargs > ThreadArgs)
		TooSmall(nargs);
	ThreadAlloc(t);
	ASSERT(t->type == ThreadType);
	t->func = fn;
	t->numargs = nargs;
	t->stack = NULL;
	if (t->join.status = join)
		{
		SLNPInit(&t->join.lock);
		t->join.waiter = NULL;
		}

/* fill in the arguments, in reverse order */
	top = t->arglist;
	bottom = top + nargs;
	p = ((int *)&nargs) + 1;
	while (top < bottom)
		*--bottom = *p++;

#ifdef PROFILE
/* thread.c is not profiled, so the topmost item on the old stack is useful */
		{
		IdStackEntry *s;
	
		SetStateOverhead();
		s = pP.thread->idStack.base - 1;
		t->idStack.top = t->idStack.base - 1; 
		while (s < pP.thread->idStack.top)
			(++(t->idStack.top))->procID = (++s)->procID & AllOffMask;
		if (name)
			{
			t->p = SynchInit(name, VarThread);
			TPushOnIdStack(t, t->p, (unsigned int)ReadyState);
			t->p->thread = t;	/* enable profiling of this thread */
			}
		else
			t->p = NULL;
		SetStateNormal();
		}
#endif
	ReadyQPut(t);
	return(t);
	}

void ThreadJoin (t)
	Thread *t;
	{
	ASSERT(t->type == ThreadType);
	ASSERT(t->join.status == JOIN || t->join.status == CALLEE_DONE);
	SLNPAcquire(&t->join.lock);
	if (t->join.status == CALLEE_DONE)
		{ ThreadFree(t); }
	else 
		{
		t->join.waiter = pP.thread;
		t->join.status = CALLER_READY;
#ifdef PROFILE
		if (t->p)
			t->p->number[1]++;
#endif
		BlockNoProf(&t->join.lock);
		}
	}

/* upper bound is non-inclusive -- calls synchronously */

/* This might not work: the problem is making sure: theoROFILEp(s r
 * doesn't sa- cf abouhe old k is uaf= pPwd k ifn,pnIdsurements, in

/* ThiRGS*/
Thre ThreadJoinMultit (fn, join, name, nargs)
	v, lb, ub revcroid (*fn)();
	int join;
	char *name;
	int nargs;
	{, lb, ub revcr
	ASSEnargmid;read *t;
	{
	 (t->j(ub; 
lb) <=revcroid	t->jOnIdN)
		(s;
	{, &l		}
	bfn		}
#ePopN)
		(s;
	{	}
	}

/mid(int ub;+
lb) / 2)
	 (OnIdN)
		(s;
	{; 
2, &evcro; (OnId)
	(mid( 
	o; (OnIdN)
		(5, &);
f (t->j(mid( 
lb) <=revcroid	threadTypet (fn		}
#
			t->t->jOnId)
	(s;
	{;+ 4	}
#ePnId)
	(s;me	}
#ePnId)
	()
		{}
#ePnId)
	(adJoinMultit (fn	t->johreadTypet (fn		}
#ePopN)
		(4	}
	}

/PopN)
		(s;
	{;+ 4	}
 (OnIdN)
		(s;
	{; 
1, &ubo; (OnId)
	(mid)
	 (t->j(ub; 
mid) <=revcroid	fn		}
#
			t->t->jOnIdN)
		(3, &);
f (	adJoinMultit (fn		}
#ePopN)
		(3	}
	}

/PopN)
		(s;
	{
f (t->j)
		{
		adJoin (t)
	}

voiif
		Benabef PRESTO

/*